<?php

	/*
	 * Public Methods Name: please follow the same nomenclature than sbcapi (nodejs server)
	 */

require_once('/usr/local/www/berogui/includes/beronode/Api.php');

class VpnApi extends Api {

	/* [CONSTRUCTOR] */
	function __construct() {
		if (is_null($loaded)) {
			parent::__construct();
		}
		else {
			$this->socket = $loaded->socket;
			$this->has_error = $loaded->has_error;
			$this->socket_error = $loaded->socket_error;
		}
	}

	/* [PUBLIC METHODS] */
	// Client Management \\
	public function clientDownloadConfiguration(int $id) {
		if ($this->has_error) {
			return $this->getError();
		}
		return $this->sendRequest('get', "/Vpn/Client/$id", null, ['withoutJsonDecode' => true]);
	}

	public function clientKill(int $id, Array $client) {
		if ($this->has_error) {
			return $this->getError();
		}
		return $this->sendRequest('delete', "/Vpn/Client/$id", $client);
	}

	// Server Management \\
	public function serverStart(int $id, Array $data) {
		if ($this->has_error) {
			return $this->getError();
		}
		return $this->sendRequest('post', "/Vpn/Server/$id", $data);
	}

	public function serverState(int $id, string $server_ip) {
		if ($this->has_error) {
			return $this->getError();
		}
		$res = $this->sendRequest('get', "/Vpn/Server/$id");
		if (isset($res['output']) && preg_match("/.*CONNECTED,SUCCESS,$server_ip.*/", $res['output'])) {
			return ['state' => 'RUNNING'];
		}
		// errors
		return ['error' => $res];
	}

	public function serverStop(int $id) {
		if ($this->has_error) {
			return $this->getError();
		}
		return $this->sendRequest('delete', "/Vpn/Server/$id");
	}
}
